package Controllers;

import Model.Person;
import Repository.PersonRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.RequestEntity;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

@RestController
public class PersonController {

    private final PersonRepository personRepository;
    @Autowired
    public PersonController(PersonRepository personRepository) {
        this.personRepository = personRepository;
    }

    @RequestMapping(value = "/person",method = RequestMethod.GET)
    public ResponseEntity<Iterable<Person>> getPersonList(){
        Iterable<Person> listOfPeople = personRepository.findAll();
        return new ResponseEntity<>(listOfPeople, HttpStatus.OK);
    }

    @RequestMapping(value = "/person",method = RequestMethod.POST)
    public ResponseEntity<Person> createPerson(@RequestBody Person p){
        return new ResponseEntity<>(this.personRepository.save(p),HttpStatus.CREATED);
    }

    @RequestMapping(value = "/person/{id}", method = RequestMethod.GET)
    public ResponseEntity<Person> getPerson(@PathVariable Long id){

        if(this.personRepository.exists(id)){
            return new ResponseEntity<>(this.personRepository.findOne(id), HttpStatus.OK);
        }else{
            return new ResponseEntity<>(HttpStatus.NOT_FOUND);
        }

    }

    @RequestMapping(value = "/person/{id}", method = RequestMethod.PUT)
    public ResponseEntity<Person> updatePerson(@PathVariable Long id,@RequestBody Person p){

        if(!this.personRepository.exists(id)){
            return new ResponseEntity<>(this.personRepository.findOne(id), HttpStatus.OK);

        }else{
            Person people = personRepository.save(p);
            people.setFirstName(p.getFirstName());
            people.setLastName(p.getLastName());
            return new ResponseEntity<>(this.personRepository.findOne(id),HttpStatus.OK);

        }

    }

    @RequestMapping(value = "/person/{id}",method = RequestMethod.DELETE)
    public void DeletePerson(@PathVariable Long id) {
    }

}